; 
; TAG-list for cross-references from words to files.
; A number of commands exist to control the procedure.

;
;  A TAG (i.e. the character string that acts as a TAG) may be up to
;   128 characters long.
;  A TAG-file has the file extension '.tag' or '.TAG'.

;
; Command         Effect
; ---------------------------------------------------------------
;
; @file$("<",">")  
;
; Extracts the TAG-Link file path from the text that follows the TAG
; and that is enclosed by the two specified characters. 



; The actual Tag function '@tag(..)' and its parameters:
; ====================================================== 

; The text of the first parameter within the double quote marks is the
; search text, which when passed executes the tag. 

; The text of the second parameter within the double quote marks or 
; the inclusion of a text function such as '@file$()', denotes the 
; search path of the file that is then to be opened by the TAG. 

; newflag: If one has entered TRUE here, then a new window will be
; opened for the TAG-Link file. If the current text (from which the TAG
; was activated) is to be replaced, then one has to enter FALSE here.

; saveflag: If one has entered TRUE here, then  the current file (from
; which the TAG was activated) will be saved before the file defined
; in the TagLink is opened.

; Example 1 :
; ================================================================

;@tag("hallo","f:\test.txt",true,false)

; If the text 'hallo' (without quotes) is selected and activated as a
; Tag (i.e. press F1), then the file test.txt from f\: will be loaded
; into a new window.

; Example 2 :
; ================================================================

;@tag("include",@file$("<",">"),false,true)

; If the text 'include' (without quotes) is selected and activated as a
; Tag, then the file whose path is specified after 'include' in angle
; brackets will be loaded as a replacement in the current window.
; Before this the active text will be saved (because there is a 'true'
; for saveflag). 

; For testing:

@tag("hallo","f:\test.txt",true,false)
@tag("include",@file$("<",">"),false,true)
@tag("class",@file$("<",">"),false,true)
@tag("module",@file$("<",">"),false,true)




